Subject: [stir] PASSporT extensions: order of claims

From: Christer Holmberg <[email-masked]>
Date: Sat, 10 Mar 2018 13:25:44 +0000

Hi,

Section  says:

   "Specifications that define extensions to the PASSporT mechanism MUST
   explicitly specify what claims they include beyond the base set of
   claims from this document, the order in which they will appear,..."

When looking at the extensions we are currently working on:

draft-ietf-stir-rph-03
draft-ietf-stir-passport-shaken-01
draft-ietf-stir-passport-divert-02

...I don't see anything about the order in any of the documents.

I think it would be good to have a dedicated "Order of claims" section, or something similar, in each extension specification.

When looking at the examples in the drafts above, it seems like even the base claims are in different orders. Not sure whether there is an explicit requirement that they need to be in order, thought.

Regards,

Christer

---

From: Christer Holmberg <[email-masked]>
Date: Sat, 10 Mar 2018 13:27:48 +0000

Section 8.3 of RFC 8225, that is.

From: stir [mailto:[email-masked]] On Behalf Of Christer Holmberg
Sent: 10 March 2018 15:26
To: [email-masked]
Cc: [email-masked]
Subject: [stir] PASSporT extensions: order of claims

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

---

From: Chris Wendt <[email-masked]>
Date: Tue, 13 Mar 2018 14:00:33 -0400

I would agree with the text, the only caveat i would point out is that the extension definition has no choice to the order other than alphabetic order, so the order is essentially implied.  So, it’s sort of a technicality that maybe we didn’t anticipate, but i think technically you are correct.

-Chris

> On Mar 10, 2018, at 8:27 AM, Christer Holmberg <[email-masked]> wrote:
> 
>   <>
>    “Specifications that define extensions to the PASSporT mechanism MUST
>    claims from this document, the order in which they will appear,…”
>  
> …I don’t see anything about the order in any of the documents.
>  
> I think it would be good to have a dedicated “Order of claims” section, or something similar, in each extension specification.
>  
> _______________________________________________
> stir mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/stir

---

From: Christer Holmberg <[email-masked]>
Date: Tue, 13 Mar 2018 18:47:27 +0000

Hi,

>I would agree with the text, the only caveat i would point out is that the extension definition has
>no choice to the order other than alphabetic order, so the order is essentially implied.  So, it’s sort
>of a technicality that maybe we didn’t anticipate, but i think technically you are correct.

Not sure I understand the has-no-choice part. Where is it said that the claims must be ordered in alphabetic order? We could for sure specify it that way, but based on your e-mail it seems like it is already specified somewhere?

Regards,

Christer

On Mar 10, 2018, at 8:27 AM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:

From: stir [mailto:[email-masked]] On Behalf Of Christer Holmberg
Sent: 10 March 2018 15:26
To: [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: [stir] PASSporT extensions: order of claims

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

_______________________________________________
stir mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/stir

---

From: Christer Holmberg <[email-masked]>
Date: Tue, 13 Mar 2018 19:58:10 +0000

Hi,

>Try RFC 8225, Section 9, perhaps?

Ok, so if that’s a generic rule, why the statement saying that PASSporT extensions must specify the order?

Regards,

Christer

From: Christer Holmberg [mailto:[email-masked]]
Sent: Tuesday, March 13, 2018 2:47 PM
To: Chris Wendt <[email-masked]<mailto:[email-masked]>>
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [stir] PASSporT extensions: order of claims

Hi,

Regards,

Christer

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

_______________________________________________
stir mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/stir<https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_stir&d=DwMGaQ&c=MOptNlVtIETeDALC_lULrw&r=ww1S9BHEcpE4MMUbgGQrsoL-SK3UCGY33Koaj2h9zYw&m=_DBdmUKpkUAUVv120PuHoMt-TVtTuzOHsfFQdAWmeFs&s=yYY6kvNSlx7W84nXLfYP7n4PSH0S7Uiq3VK2FI6iwEU&e=>

---

From: "Politz, Ken" <[email-masked]>
Date: Tue, 13 Mar 2018 19:18:56 +0000

Try RFC 8225, Section 9, perhaps?  Ken.

From: Christer Holmberg [mailto:[email-masked]]
Sent: Tuesday, March 13, 2018 2:47 PM
To: Chris Wendt <[email-masked]>
Cc: [email-masked]; [email-masked]
Subject: Re: [stir] PASSporT extensions: order of claims

Hi,

Regards,

Christer

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

---

From: "Politz, Ken" <[email-masked]>
Date: Tue, 13 Mar 2018 21:35:25 +0000

That, I can’t answer ☺

From: Christer Holmberg [mailto:[email-masked]]
Sent: Tuesday, March 13, 2018 3:58 PM
To: Politz, Ken <[email-masked]>; Chris Wendt <[email-masked]>
Cc: [email-masked]; [email-masked]
Subject: Re: [stir] PASSporT extensions: order of claims

Hi,

Regards,

Christer

Hi,

Regards,

Christer

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

---

From: Chris Wendt <[email-masked]>
Date: Wed, 14 Mar 2018 07:36:05 -0400

Perhaps its a bit over prescriptive, i think the intention was only to say that it should be documented what claims and provide order and examples.  It wasn’t to imply that it would be different or there would be implications of order or anything.

To step up a level, in general, JSON object key order never matters, it’s a key value object that you index on key, so order in most cases is arbitrary.  For PASSporT, we have a short form that is supported in RFC8224, where you don’t need to send the header/claims because those objects are already in the SIP INVITE.  So we needed a way to have the header/claims to be reconstructed in a predictable and reproducible way.  An therefore the dependency on order.

So again, yes we say you should say order in RFC8225, which i would say would inherently be the case with an example at a minimum.  A MUST might have been a bit strong, but i don’t see this as a huge concern.  I’d be curious to hear from others whether they think this is a real concern or not.

> On Mar 13, 2018, at 3:58 PM, Christer Holmberg <[email-masked]> wrote:
> 
> Hi,
>  
> From: Christer Holmberg [mailto:[email-masked] <mailto:[email-masked]>] 
> To: Chris Wendt <[email-masked] <mailto:[email-masked]>>
> Cc: [email-masked] <mailto:[email-masked]>; [email-masked] <mailto:[email-masked]>
> On Mar 10, 2018, at 8:27 AM, Christer Holmberg <[email-masked] <mailto:[email-masked]>> wrote:
>  
> From: stir [mailto:[email-masked] <mailto:[email-masked]>] On Behalf Of Christer Holmberg
> To: [email-masked] <mailto:[email-masked]>
> Cc: [email-masked] <mailto:[email-masked]>
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/stir <https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_stir&d=DwMGaQ&c=MOptNlVtIETeDALC_lULrw&r=ww1S9BHEcpE4MMUbgGQrsoL-SK3UCGY33Koaj2h9zYw&m=_DBdmUKpkUAUVv120PuHoMt-TVtTuzOHsfFQdAWmeFs&s=yYY6kvNSlx7W84nXLfYP7n4PSH0S7Uiq3VK2FI6iwEU&e=>

---

From: Christer Holmberg <[email-masked]>
Date: Wed, 14 Mar 2018 12:00:33 +0000

Hi,

> Perhaps its a bit over prescriptive, i think the intention was only to say that it should be documented what claims and provide order and examples.
>
> It wasn’t to imply that it would be different or there would be implications of order or anything.
>
> To step up a level, in general, JSON object key order never matters, it’s a key value object that you index on key, so order in most cases is arbitrary.  For PASSporT, we
> have a short form that is supported in RFC8224, where you don’t need to send the header/claims because those objects are already in the SIP INVITE.  So we needed a
> way to have the header/claims to be reconstructed in a predictable and reproducible way.  An therefore the dependency on order.

Correct. I wasn’t questioning the need for ordering, but maybe I wasn’t clear about that :)

> So again, yes we say you should say order in RFC8225, which i would say would inherently be the case with an example at a minimum.  A MUST might have been
> a bit strong, but i don’t see this as a huge concern.  I’d be curious to hear from others whether they think this is a real concern or not.

It depends on what is meant by “concern”. When people define PASSporT extensions future, they will not look at this e-mail thread – they will read RFC8225. We shouldn’t have MUSTs if they don’t mean anything.

Anyway, as far as the current PASSporT extensions are concerned, maybe we could solve the issue by including a statement saying something like:

“The order of the claims within the PASSporT <insert-name-of-PASSporT extension> JSON object does not matter. However, as defined in Section 9 of RFC8225, when the JSON serialisation takes place, the claims must be placed in lexicographic order”

Regards,

Christer

On Mar 13, 2018, at 3:58 PM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:

Hi,

Regards,

Christer

Hi,

Regards,

Christer

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

---

From: Chris Wendt <[email-masked]>
Date: Wed, 14 Mar 2018 09:32:13 -0400

To be clear, and i think this was the point of my last e-mail, I’m not suggesting it doesn’t mean anything.  It certainly is good to be explicit about the order and provide examples and if that’s all you are suggesting, i can’t disagree.

I think at some point in the e-mail thread you were questioning the logic of the MUST for providing details of the order of claims in RFC8225 and that’s what i was trying to address.  I think we are going in circles at this point, so i’ll let others comment.

> On Mar 14, 2018, at 8:00 AM, Christer Holmberg <[email-masked]> wrote:
> 
> Hi,
> 
>> On Mar 13, 2018, at 3:58 PM, Christer Holmberg <[email-masked] <mailto:[email-masked]>> wrote:
>> 
>> Hi,
>>

---

From: Christer Holmberg <[email-masked]>
Date: Wed, 14 Mar 2018 13:38:26 +0000

Hi,

>I think at some point in the e-mail thread you were questioning the logic of the MUST for providing details of the order of claims in RFC8225 and that’s what i was trying to address.

My initial comment was that the current PASSporT extensions do not provide details of the order, and that we should fix that :)

Later, I questioned the logic of the MUST when I was told that RFC8225 already defines the order for extensions.

Regards,

Christer

On Mar 14, 2018, at 8:00 AM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:

Hi,

Regards,

Christer

Hi,

Regards,

Christer

Hi,

Regards,

Christer

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

---

From: "Politz, Ken" <[email-masked]>
Date: Wed, 14 Mar 2018 13:42:51 +0000

All I can say is that, with relatively limited SHAKEN industry testing, JSON key order has come up twice.  As new extensions get added and for interoperability purposes, I would request that clarity be provided in related specs with consistent examples for implementers.  Thanks, Ken.

From: Chris Wendt [mailto:[email-masked]]
Sent: Wednesday, March 14, 2018 7:36 AM
To: Christer Holmberg <[email-masked]>
Cc: Politz, Ken <[email-masked]>; [email-masked]; [email-masked]
Subject: [EXTERNAL] Re: [stir] PASSporT extensions: order of claims

Hi,

Regards,

Christer

Hi,

Regards,

Christer

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

---

From: "Gorman, Pierce A [CTO]" <[email-masked]>
Date: Wed, 14 Mar 2018 19:09:44 +0000

Chris,

The collective body of work from TN PoP, RPH extension, the recent SIPcoin and call-back RFC drafts make me think future innovation involving multiple Identity headers and/or a need of order of JSON keys is more likely than not.  Is this a bad assumption?

Pierce

From: Politz, Ken [mailto:[email-masked]]
Sent: Wednesday, March 14, 2018 8:43 AM
To: Chris Wendt <[email-masked]>; Christer Holmberg <[email-masked]>
Cc: [email-masked]; [email-masked]
Subject: Re: [stir] [EXTERNAL] Re: PASSporT extensions: order of claims

From: Chris Wendt [mailto:[email-masked]]
Sent: Wednesday, March 14, 2018 7:36 AM
To: Christer Holmberg <[email-masked]<mailto:[email-masked]>>
Cc: Politz, Ken <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: [EXTERNAL] Re: [stir] PASSporT extensions: order of claims

Hi,

Regards,

Christer

Hi,

Regards,

Christer

Hi,

Section  says:

draft-ietf-stir-rph-03

Regards,

Christer

________________________________

This e-mail may contain Sprint proprietary information intended for the sole use of the recipient(s). Any use by others is prohibited. If you are not the intended recipient, please contact the sender and delete all copies of the message.